package Linode::Longview::DataGetter::CPU;

use Linode::Longview::Util ':BASIC';

sub get {
	my (undef, $dataref) = @_;

	$logger->trace('Collecting CPU info');

	my $ts = time;
	my @stat_file = slurp_file( $PROCFS . 'stat' ) or do{
		$logger->info("Couldn't check ${PROCFS}stat: $!");
		return $dataref;
	};
	shift @stat_file;    #first line is combined, pitch it
	for my $line (@stat_file) {
		last unless $line =~ m/^(cpu\d+)\s+/;
		my ( $user, $nice, $system, $idle, $wait )
			= ( split /\s+/, $line )[ 1 .. 5 ];
		$dataref->{LONGTERM}->{"CPU.$1.user"} = $user + $nice;
		$dataref->{LONGTERM}->{"CPU.$1.system"} = $system + 0;
		$dataref->{LONGTERM}->{"CPU.$1.wait"} = $wait + 0;
	}

	$logger->trace('Collecting load average');
	my $load = ( split( /\s/, ( slurp_file( $PROCFS . 'loadavg' ) )[0], 2 ) )[0] or do {
		$logger->info("Couldn't check ${PROCFS}loadavg: $!");
		return $dataref;
	};
	$dataref->{LONGTERM}->{Load} = $load + 0;

	return $dataref;
}

1;
