package Linode::Longview::DataGetter::Network;

use Linode::Longview::Util ':BASIC';

sub get {
	my (undef, $dataref) = @_;

	$logger->trace('Collecting network traffic info');

	my @data = slurp_file( $PROCFS . 'net/dev' ) or do {
		$logger->info("Couldn't read ${PROCFS}net/dev: $!");
		return $dataref;
	};

	for my $line (@data) {
		next unless $line =~ /^\s*.*?:/;
		$line =~ s/^\s*//;
		my ( $dev, $rx_bytes, $tx_bytes ) = ($line =~ /^\s*?(\S*?):\s*(\d+)(?:(\d+)|(\s+)){16}(\d+)/);
		next if ( $rx_bytes == 0 && $tx_bytes == 0 );
		$dev =~ s/:$//;
		$dev =~ s/\./\\\./g;

		$dataref->{LONGTERM}->{"Network.Interface.$dev.rx_bytes"} = $rx_bytes + 0;
		$dataref->{LONGTERM}->{"Network.Interface.$dev.tx_bytes"} = $tx_bytes + 0;
	}
	$dataref->{INSTANT}->{'Network.mac_addr'} = slurp_file('/sys/class/net/eth0/address');
	return $dataref;
}

1;

