package Linode::Longview::DataGetter::Packages;

use Linode::Longview::Util;
require $_ for glob('Linode/Longview/DataGetter/Packages/*.pm');

sub get {
	my (undef, $dataref) = @_;
	$logger->trace('Collecting Package information');

	return "Linode::Longview::DataGetter::Packages::@{[determine_pkg_tool($dataref)]}"->get($dataref);
}

sub determine_pkg_tool {
	my $dataref = shift;
	my $dist = $dataref->{INSTANT}->{'SysInfo.os.dist'};
	return 'APT' if ( $dist =~ /debian/i || $dist =~ /ubuntu/i );
	return 'YUM' if ( $dist =~ /centos/i || $dist =~ /fedora/i );
	return 'Gentoo' if ( $dist =~ /gentoo/i );
	return 'unknown';
}

1;
