package Linode::Longview::DataGetter::Packages::Gentoo;

use 5.010;
use feature 'state';

use Linode::Longview::Util;

sub get {
	my ( undef, $dataref ) = @_;
	state @pkgs;

	$logger->trace('Entering Gentoo module');

	if(should_update()){
		@pkgs = qx(VERSION='<version>,' eix -u '-*' --format '<category>/<name> <installedversions:VERSION> <bestslotupgradeversions:VERSION>\n');
	}

	$dataref->{INSTANT}->{Packages} = [
		map {
			my ($name, $current, $new) = $_ =~ /^([^ ]+) (.+?), (.+?),$/;
			{
				name    => $name,
				current => join(', ', split(/,/, $current)),
				new     => join(', ', split(/,/, $new))
			}
		} @pkgs
	];
	return $dataref;
}

sub should_update {
	state $next_run;
	return 0 if((defined $next_run) && ($next_run > time));
	$next_run = time + 1800; # Checking updates is expensive; only do it every 30 minutes
	return 1;
}

1;