package Linode::Longview::DataGetter::Packages::YUM;

use Linode::Longview::Util;

sub get {
	my (undef, $dataref) = @_;

	$logger->trace('Entering YUM module');

	my %u_pkgs = upgradable_pkgs();
	if (!%u_pkgs){
		$dataref->{INSTANT}->{Packages} = [];
		return $dataref;
	}
	my %c_pkgs = current_pkgs();
	$dataref->{INSTANT}->{Packages} = [
		map {
			{
				name => $_,
				current => $c_pkgs{$_},
				new => $u_pkgs{$_}
			}
		}
		keys %u_pkgs
	];
	return $dataref;
}

sub current_pkgs {
	# yum wraps unless we fake a tty
	my @pkg_list = qx(script -c 'yum --color=never list installed' /dev/null);
	my %pkgs;
	for my $pkg (@pkg_list) {
		if ( $pkg =~ m/^(.*?)\s+(.*?)\s+@(.*)$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

sub upgradable_pkgs {
	my @pkg_list = qx(yum check-update);
	my %pkgs;
	for my $pkg (@pkg_list) {
		if ( $pkg =~ m/^(\S+)\s+(\S+)\s+\S+$/ ) {
			$pkgs{$1} = $2;
		}
	}
	return %pkgs;
}

1;
